
var symdesc = {
	"ean5": { sym: "ean5", desc: "EAN-5 (5 digit addon)", text: "90200", opts: "includetext guardwhitespace" },
	"ean2": { sym: "ean2", desc: "EAN-2 (2 digit addon)", text: "05", opts: "includetext guardwhitespace" },
	"ean13": { sym: "ean13", desc: "EAN-13", text: "2112345678900", opts: "includetext guardwhitespace" },
	"ean8": { sym: "ean8", desc: "EAN-8", text: "02345673", opts: "includetext guardwhitespace" },
	"upca": { sym: "upca", desc: "UPC-A", text: "416000336108", opts: "includetext" },
	"upce": { sym: "upce", desc: "UPC-E", text: "00123457", opts: "includetext" },
	"isbn": { sym: "isbn", desc: "ISBN", text: "978-1-56581-231-4 52250", opts: "includetext guardwhitespace" },
	"ismn": { sym: "ismn", desc: "ISMN", text: "979-0-2605-3211-3", opts: "includetext guardwhitespace" },
	"issn": { sym: "issn", desc: "ISSN", text: "0311-175X 00 17", opts: "includetext guardwhitespace" },
	"code128": { sym: "code128", desc: "Code 128", text: "Count01234567^FNC2!", opts: "includetext parsefnc" },
	"gs1-128": { sym: "gs1-128", desc: "GS1-128", text: "(01)95012345678903(3103)000123", opts: "includetext" },
	"ean14": { sym: "ean14", desc: "GS1-14", text: "(01) 0 46 01234 56789 3", opts: "includetext" },
	"sscc18": { sym: "sscc18", desc: "SSCC-18", text: "(00) 0 0614141 123456789 0", opts: "includetext" },
	"code39": { sym: "code39", desc: "Code 39", text: "THIS IS CODE 39", opts: "includetext includecheck includecheckintext" },
	"code39ext": { sym: "code39ext", desc: "Code 39 Extended", text: "Code39 Ext!", opts: "includetext includecheck includecheckintext" },
	"code32": { sym: "code32", desc: "Italian Pharmacode", text: "01234567", opts: "includetext" },
	"pzn": { sym: "pzn", desc: "Pharmazentralnummer (PZN)", text: "123456", opts: "includetext" },
	"code93": { sym: "code93", desc: "Code 93", text: "THIS IS CODE 93", opts: "includetext includecheck" },
	"code93ext": { sym: "code93ext", desc: "Code 93 Extended", text: "Code93 Ext!", opts: "includetext includecheck" },
	"interleaved2of5": { sym: "interleaved2of5", desc: "Interleaved 2 of 5 (ITF)", text: "2401234567", opts: "height=0.5 includecheck includetext includecheckintext" },
	"itf14": { sym: "itf14", desc: "ITF-14", text: "0 46 01234 56789 3", opts: "includetext" },
	"identcode": { sym: "identcode", desc: "Deutsche Post Identcode", text: "563102430313", opts: "includetext" },
	"leitcode": { sym: "leitcode", desc: "Deutsche Post Leitcode", text: "21348075016401", opts: "includetext" },
	"databaromni": { sym: "databaromni", desc: "GS1 DataBar Omnidirectional", text: "(01)24012345678905", opts: "" },
	"databarstacked": { sym: "databarstacked", desc: "GS1 DataBar Stacked", text: "(01)24012345678905", opts: "" },
	"databarstackedomni": { sym: "databarstackedomni", desc: "GS1 DataBar Stacked Omnidirectional", text: "(01)24012345678905", opts: "" },
	"databartruncated": { sym: "databartruncated", desc: "GS1 DataBar Truncated", text: "(01)24012345678905", opts: "" },
	"databarlimited": { sym: "databarlimited", desc: "GS1 DataBar Limited", text: "(01)15012345678907", opts: "" },
	"databarexpanded": { sym: "databarexpanded", desc: "GS1 DataBar Expanded", text: "(01)95012345678903(3103)000123", opts: "" },
	"databarexpandedstacked": { sym: "databarexpandedstacked", desc: "GS1 DataBar Expanded Stacked", text: "(01)95012345678903(3103)000123", opts: "segments=4" },
	"pharmacode": { sym: "pharmacode", desc: "Pharmaceutical Binary Code", text: "117480", opts: "showborder" },
	"pharmacode2": { sym: "pharmacode2", desc: "Two-track Pharmacode", text: "117480", opts: "includetext showborder" },
	"code2of5": { sym: "code2of5", desc: "Code 25", text: "01234567", opts: "includetext includecheck includecheckintext" },
	"industrial2of5": { sym: "industrial2of5", desc: "Industrial 2 of 5", text: "01234567", opts: "includetext includecheck includecheckintext" },
	"iata2of5": { sym: "iata2of5", desc: "IATA 2 of 5", text: "01234567", opts: "includetext includecheck includecheckintext" },
	"matrix2of5": { sym: "matrix2of5", desc: "Matrix 2 of 5", text: "01234567", opts: "includetext includecheck includecheckintext" },
	"coop2of5": { sym: "coop2of5", desc: "COOP 2 of 5", text: "01234567", opts: "includetext includecheck includecheckintext" },
	"datalogic2of5": { sym: "datalogic2of5", desc: "Datalogic 2 of 5", text: "01234567", opts: "includetext includecheck includecheckintext" },
	"code11": { sym: "code11", desc: "Code 11", text: "0123456789", opts: "includetext includecheck includecheckintext" },
	"bc412": { sym: "bc412", desc: "BC412", text: "BC412", opts: "semi includetext includecheckintext" },
	"rationalizedCodabar": { sym: "rationalizedCodabar", desc: "Codabar", text: "A0123456789B", opts: "includetext includecheck includecheckintext" },
	"onecode": { sym: "onecode", desc: "USPS Intelligent Mail", text: "0123456709498765432101234567891", opts: "barcolor=FF0000" },
	"postnet": { sym: "postnet", desc: "USPS POSTNET", text: "01234", opts: "includetext includecheckintext" },
	"planet": { sym: "planet", desc: "USPS PLANET", text: "01234567890", opts: "includetext includecheckintext" },
	"royalmail": { sym: "royalmail", desc: "Royal Mail 4 State Customer Code", text: "LE28HS9Z", opts: "includetext barcolor=FF0000" },
	"auspost": { sym: "auspost", desc: "AusPost 4 State Customer Code", text: "5956439111ABA 9", opts: "includetext custinfoenc=character" },
	"kix": { sym: "kix", desc: "Royal Dutch TPG Post KIX", text: "1231FZ13XHS", opts: "includetext" },
	"japanpost": { sym: "japanpost", desc: "Japan Post 4 State Customer Code", text: "6540123789-A-K-Z", opts: "includetext includecheckintext" },
	"msi": { sym: "msi", desc: "MSI Modified Plessey", text: "0123456789", opts: "includetext includecheck includecheckintext" },
	"plessey": { sym: "plessey", desc: "Plessey UK", text: "01234ABCD", opts: "includetext includecheckintext" },
	"telepen": { sym: "telepen", desc: "Telepen", text: "ABCDEF", opts: "includetext" },
	"telepennumeric": { sym: "telepennumeric", desc: "Telepen Numeric", text: "01234567", opts: "includetext" },
	"posicode": { sym: "posicode", desc: "PosiCode", text: "ABC123", opts: "version=b inkspread=-0.5 parsefnc includetext" },
	"codablockf": { sym: "codablockf", desc: "Codablock F", text: "CODABLOCK F 34567890123456789010040digit", opts: "columns=8" },
	"code16k": { sym: "code16k", desc: "Code 16K", text: "Abcd-1234567890-wxyZ", opts: "" },
	"code49": { sym: "code49", desc: "Code 49", text: "MULTIPLE ROWS IN CODE 49", opts: "" },
	"channelcode": { sym: "channelcode", desc: "Channel Code", text: "3493", opts: "height=0.5 includetext " },
	"flattermarken": { sym: "flattermarken", desc: "Flattermarken", text: "11099", opts: "inkspread=-0.25 showborder borderleft=0 borderright=0" },
	"raw": { sym: "raw", desc: "Custom 1D symbology", text: "331132131313411122131311333213114131131221323", opts: "height=0.5" },
	"daft": { sym: "daft", desc: "Custom 4 state symbology", text: "FATDAFTDAD", opts: "" },
	"symbol": { sym: "symbol", desc: "Miscellaneous symbols", text: "fima", opts: "backgroundcolor=DD000011" },
	"pdf417": { sym: "pdf417", desc: "PDF417", text: "This is PDF417", opts: "columns=2" },
	"pdf417compact": { sym: "pdf417compact", desc: "Compact PDF417", text: "This is compact PDF417", opts: "columns=2" },
	"micropdf417": { sym: "micropdf417", desc: "MicroPDF417", text: "MicroPDF417", opts: "" },
	"datamatrix": { sym: "datamatrix", desc: "Data Matrix", text: "This is Data Matrix!", opts: "" },
	"qrcode": { sym: "qrcode", desc: "QR Code", text: "http://goo.gl/0bis", opts: "eclevel=M" },
	"microqrcode": { sym: "microqrcode", desc: "Micro QR Code", text: "1234", opts: "" },
	"maxicode": { sym: "maxicode", desc: "MaxiCode", text: "[)>^03001^02996152382802^029840^029001^0291Z00004951^029UPSN^02906X610^029159^0291234567^0291/1^029^029Y^029634 ALPHA DR^029PITTSBURGH^029PA^029^004", opts: "mode=2 parse" },
	"azteccode": { sym: "azteccode", desc: "Aztec Code", text: "This is Aztec Code", opts: "format=full" },
	"azteccodecompact": { sym: "azteccodecompact", desc: "Compact Aztec Code", text: "1234", opts: "" },
	"aztecrune": { sym: "aztecrune", desc: "Aztec Runes", text: "1", opts: "" },
	"codeone": { sym: "codeone", desc: "Code One", text: "Code One", opts: "version=B" },
	"gs1-cc": { sym: "gs1-cc", desc: "GS1 Composite 2D Component", text: "(01)95012345678903(3103)000123", opts: "ccversion=b cccolumns=4" },
	"ean13composite": { sym: "ean13composite", desc: "EAN-13 Composite", text: "2112345678900|(99)1234-abcd", opts: "includetext" },
	"ean8composite": { sym: "ean8composite", desc: "EAN-8 Composite", text: "02345673|(21)A12345678", opts: "includetext" },
	"upcacomposite": { sym: "upcacomposite", desc: "UPC-A Composite", text: "416000336108|(99)1234-abcd", opts: "includetext" },
	"upcecomposite": { sym: "upcecomposite", desc: "UPC-E Composite", text: "00123457|(15)021231", opts: "includetext" },
	"databaromnicomposite": { sym: "databaromnicomposite", desc: "GS1 DataBar Omnidirectional Composite", text: "(01)03612345678904|(11)990102", opts: "" },
	"databarstackedcomposite": { sym: "databarstackedcomposite", desc: "GS1 DataBar Stacked Composite", text: "(01)03412345678900|(17)010200", opts: "" },
	"databarstackedomnicomposite": { sym: "databarstackedomnicomposite", desc: "GS1 DataBar Stacked Omnidirectional Composite", text: "(01)03612345678904|(11)990102", opts: "" },
	"databartruncatedcomposite": { sym: "databartruncatedcomposite", desc: "GS1 DataBar Truncated Composite", text: "(01)03612345678904|(11)990102", opts: "" },
	"databarlimitedcomposite": { sym: "databarlimitedcomposite", desc: "GS1 DataBar Limited Composite", text: "(01)03512345678907|(21)abcdefghijklmnopqrstuv", opts: "" },
	"databarexpandedcomposite": { sym: "databarexpandedcomposite", desc: "GS1 DataBar Expanded Composite", text: "(01)93712345678904(3103)001234|(91)1A2B3C4D5E", opts: "" },
	"databarexpandedstackedcomposite": { sym: "databarexpandedstackedcomposite", desc: "GS1 DataBar Expanded Stacked Composite", text: "(01)00012345678905(10)ABCDEF|(21)12345678", opts: "segments=4 " },
	"gs1-128composite": { sym: "gs1-128composite", desc: "GS1-128 Composite", text: "(00)030123456789012340|(02)13012345678909(37)24(10)1234567ABCDEFG", opts: "ccversion=c" },
	"gs1datamatrix": { sym: "gs1datamatrix", desc: "GS1 Data Matrix", text: "(01)03453120000011(17)120508(10)ABCD1234(410)9501101020917", opts: "" },
	"gs1qrcode": { sym: "gs1qrcode", desc: "GS1 QR Code", text: "(01)03453120000011(8200)http://www.abc.net(10)ABCD1234(410)9501101020917", opts: "" },
	"hibccode39": { sym: "hibccode39", desc: "HIBC Code 39", text: "A123BJC5D6E71", opts: "includetext" },
	"hibccode128": { sym: "hibccode128", desc: "HIBC Code 128", text: "A123BJC5D6E71", opts: "includetext" },
	"hibcdatamatrix": { sym: "hibcdatamatrix", desc: "HIBC Data Matrix", text: "A123BJC5D6E71", opts: "" },
	"hibcpdf417": { sym: "hibcpdf417", desc: "HIBC PDF417", text: "A123BJC5D6E71", opts: "" },
	"hibcmicropdf417": { sym: "hibcmicropdf417", desc: "HIBC MicroPDF417", text: "A123BJC5D6E71", opts: "" },
	"hibcqrcode": { sym: "hibcqrcode", desc: "HIBC QR Code", text: "A123BJC5D6E71", opts: "" },
	"hibccodablockf": { sym: "hibccodablockf", desc: "HIBC Codablock F", text: "A123BJC5D6E71", opts: "" }
};