function EAN(EANnumber) {

	this.EANnumber = EANnumber + "";

	this.valid = function () {
		return valid(this.EANnumber);
	};

	this.encoded = function () {
		if (valid(this.EANnumber)) {
			return createUPC(this.EANnumber);
		}
		return "";
	};

	var Lbinary = {
		0: "0001101",
		1: "0011001",
		2: "0010011",
		3: "0111101",
		4: "0100011",
		5: "0110001",
		6: "0101111",
		7: "0111011",
		8: "0110111",
		9: "0001011" };

	var Gbinary = {
		0: "0100111",
		1: "0110011",
		2: "0011011",
		3: "0100001",
		4: "0011101",
		5: "0111001",
		6: "0000101",
		7: "0010001",
		8: "0001001",
		9: "0010111" };

	var Rbinary = {
		0: "1110010",
		1: "1100110",
		2: "1101100",
		3: "1000010",
		4: "1011100",
		5: "1001110",
		6: "1010000",
		7: "1000100",
		8: "1001000",
		9: "1110100" };

	var EANstruct = {
		0: "LLLLLL",
		1: "LLGLGG",
		2: "LLGGLG",
		3: "LLGGGL",
		4: "LGLLGG",
		5: "LGGLLG",
		6: "LGGGLL",
		7: "LGLGLG",
		8: "LGLGGL",
		9: "LGGLGL" };

	var startBin = "101";

	var endBin = "101";

	var middleBin = "01010";

	var regexp = /^[0-9]{13}$/;

	function createUPC(number) {
		var result = "";

		var firstDigit = number[0];

		var leftSide = number.substr(1, 7);

		var rightSide = number.substr(7, 6);

		result += startBin;

		result += encode(leftSide, EANstruct[firstDigit]);

		result += middleBin;

		result += encode(rightSide, "RRRRRR");

		result += endBin;

		return result;
	}

	function encode(number, struct) {
		var result = "";

		for (var i = 0; i < number.length; i++) {
			if (struct[i] == "L") {
				result += Lbinary[number[i]];
			} else if (struct[i] == "G") {
				result += Gbinary[number[i]];
			} else if (struct[i] == "R") {
				result += Rbinary[number[i]];
			}
		}
		return result;
	}

	function checksum(number) {
		var result = 0;

		for (var i = 0; i < 12; i += 2) {
			result += parseInt(number[i]);
		}
		for (var i = 1; i < 12; i += 2) {
			result += parseInt(number[i]) * 3;
		}

		return (10 - result % 10) % 10;
	}

	function valid(number) {
		if (number.search(regexp) == -1) {
			return false;
		} else {
			return number[12] == checksum(number);
		}
	}
}

function UPC(UPCnumber) {

	this.ean = new EAN("0" + UPCnumber);

	this.valid = function () {
		return this.ean.valid();
	};

	this.encoded = function () {
		return this.ean.encoded();
	};
}