function ITF(ITFNumber) {

	this.ITFNumber = ITFNumber + "";

	this.valid = function () {
		return valid(this.ITFNumber);
	};

	this.encoded = function () {
		if (valid(this.ITFNumber)) {
			return encode(this.ITFNumber);
		}
		return "";
	};

	var digitStructure = {
		"0": "00110",
		"1": "10001",
		"2": "01001",
		"3": "11000",
		"4": "00101",
		"5": "10100",
		"6": "01100",
		"7": "00011",
		"8": "10010",
		"9": "01010" };

	var startBin = "1010";

	var endBin = "11101";

	var regexp = /^([0-9][0-9])+$/;

	function encode(number) {
		var result = "";

		result += startBin;

		for (var i = 0; i < number.length; i += 2) {
			result += calculatePair(number.substr(i, 2));
		}

		result += endBin;

		return result;
	}

	function calculatePair(twoNumbers) {
		var result = "";

		var number1Struct = digitStructure[twoNumbers[0]];
		var number2Struct = digitStructure[twoNumbers[1]];

		for (var i = 0; i < 5; i++) {
			result += number1Struct[i] == "1" ? "111" : "1";
			result += number2Struct[i] == "1" ? "000" : "0";
		}
		return result;
	}

	function valid(number) {
		return number.search(regexp) !== -1;
	}
}