function ITF14(ITF14number) {

	this.ITF14number = ITF14number + "";

	this.valid = function () {
		return valid(this.ITF14number);
	};

	this.encoded = function () {
		if (valid(this.ITF14number)) {
			return encode(this.ITF14number);
		}
		return "";
	};

	var digitStructure = {
		"0": "00110",
		"1": "10001",
		"2": "01001",
		"3": "11000",
		"4": "00101",
		"5": "10100",
		"6": "01100",
		"7": "00011",
		"8": "10010",
		"9": "01010" };

	var startBin = "1010";

	var endBin = "11101";

	var regexp = /^[0-9]{13,14}$/;

	function encode(number) {
		var result = "";

		if (number.length == 13) {
			number += checksum(number);
		}

		result += startBin;

		for (var i = 0; i < 14; i += 2) {
			result += calculatePair(number.substr(i, 2));
		}

		result += endBin;

		return result;
	}

	function calculatePair(twoNumbers) {
		var result = "";

		var number1Struct = digitStructure[twoNumbers[0]];
		var number2Struct = digitStructure[twoNumbers[1]];

		for (var i = 0; i < 5; i++) {
			result += number1Struct[i] == "1" ? "111" : "1";
			result += number2Struct[i] == "1" ? "000" : "0";
		}
		return result;
	}

	function checksum(numberString) {
		var result = 0;

		for (var i = 0; i < 13; i++) {
			result += parseInt(numberString[i]) * (3 - i % 2 * 2);
		}

		return 10 - result % 10;
	}

	function valid(number) {
		if (number.search(regexp) == -1) {
			return false;
		} else if (number.length == 14) {
				return number[13] == checksum(number);
			}
		return true;
	}
}